// STUploadDoc.cpp : implementation of the CSTUploadDoc class
//

#include "stdafx.h"
#include "STUpload.h"

#include "STUploadDoc.h"
#include "MainFrm.h"
#include "ConflictDialog.h"

#include "QueryDialog.h" 
#include "StockDataList.h" 
#include "ResultsDialog.h"

#include <comdef.h>//      
#include <lmcons.h>//      UNLEN
#include ".\STLoadData\STLoadData.h" 
#include ".\STLoadData\STLoadData_i.c"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc

IMPLEMENT_DYNCREATE(CSTUploadDoc, CDocument)

BEGIN_MESSAGE_MAP(CSTUploadDoc, CDocument)
	//{{AFX_MSG_MAP(CSTUploadDoc)
	ON_COMMAND(ID_DATA_IMPORT, OnDataImport)
	ON_COMMAND(ID_DATA_QUERYDATABASE, OnDataQuerydatabase)
	ON_UPDATE_COMMAND_UI(ID_DATA_QUERYDATABASE, OnUpdateDataQuerydatabase)
	ON_COMMAND(ID_DATA_UPLOAD, OnDataUpload)
	ON_UPDATE_COMMAND_UI(ID_DATA_UPLOAD, OnUpdateDataUpload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc construction/destruction

CSTUploadDoc::CSTUploadDoc()
{
	m_strCurrentFund = "";
}

CSTUploadDoc::~CSTUploadDoc()
{
}

BOOL CSTUploadDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc serialization

void CSTUploadDoc::Serialize(CArchive& ar)
{
  m_DocList.Serialize( ar );

  if (ar.IsStoring())
  {
    ar << m_strCurrentFund;	
  }
  else
  {
    ar >> m_strCurrentFund;

    //      Select Fund     
    CMainFrame* pWnd = 
      dynamic_cast< CMainFrame * > (AfxGetMainWnd());

    if( pWnd ) 
    // He       
    //        
    //   
    {
      //       
      pWnd->UpdateFundList( m_DocList, m_strCurrentFund );
      pWnd->SetFundsVisible( TRUE );
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc diagnostics

#ifdef _DEBUG
void CSTUploadDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSTUploadDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSTUploadDoc commands

void CSTUploadDoc::OnDataImport() 
{
    // String to customize File Dialog
CString strFilter = "Data Files (*.dat)|*.dat|All Files (*.*)|*.*||";
CFileDialog aFileDialog( TRUE, NULL, NULL,
                    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strFilter);
int nID = aFileDialog.DoModal();
if(nID == IDOK) 
{
  CStdioFile aFile; 
  CFileException fx;
  if ( !aFile.Open( aFileDialog.GetPathName(), CFile::modeRead | CFile::typeText, &fx ) )
  {
    TCHAR buf[ 255 ];
    fx.GetErrorMessage( buf, 255 );
    CString strPrompt( buf );
    AfxMessageBox( strPrompt );
    return;
  }
  if (LoadData(aFile)) 
  {
    SetModifiedFlag();
    UpdateAllViews(NULL); 
  } 
}

	
}

BOOL CSTUploadDoc::LoadData(CStdioFile &infile)
{
  //    NULL
  ASSERT( infile.m_hFile != NULL );
	
  //       CStocData
  //    CSTUploadDoc::m_DocList  
  //   .
  CStockDataList TempList;

  //      
  TempList.AddHead( &m_DocList );

  //   	
  CString strTemp;

  //  
  COleDateTime Today = COleDateTime::GetCurrentTime();;
  COleDateTime FileDate;
  CString strFileHeader;

  int addedCtr = 0;	//    
  int discardedCtr = 0;  //   

  BOOL bFirstLine = TRUE;

  while( infile.ReadString( strTemp ) )
  {
    BOOL bValidDate = FALSE;
    CString strFund;
    CString strDate;
		
    //   
    if( strTemp.GetLength() == 0 ) continue;

    if( bFirstLine )
    {
      //    
      strFileHeader = strTemp.Left(18);
      strFileHeader.TrimRight();
      strDate = strTemp.Mid( 18, 10 );
    }
    else
    {
      strFund = strTemp.Left(8);
      strFund.TrimRight();
      strDate = strTemp.Mid( 8, 10 );
    }

    int nYear = atoi( strDate.Right( 4 ));
    int nMonth = atoi( strDate.Left( 2 ));
    int nDay = atoi( strDate.Mid( 3, 2 ));
	
    COleDateTime aDate( nYear, nMonth, nDay, 0, 0, 0 );
		
    if( aDate.GetStatus() != COleDateTime::valid )
    {
      if( bFirstLine )
      {
        //      - , 
        //   
        AfxMessageBox( "Invalid File Format" );
        return FALSE;
      }
      else
      {
        //      -  
        //  
        discardedCtr++;
        continue;
      }
    }

    if ( bFirstLine )
    {
      //     -     
      FileDate = aDate;
      bFirstLine = FALSE;
      continue;
    }

    double dPrice = atof( strTemp.Mid( 19 ));

    //   CStockData      t 
    CStockData aStData( strFund, aDate, dPrice );
    CStockDataList::errorstatus err;
    POSITION CurPos = TempList.AddSorted( aStData, err );

    switch( err )
    {
      //  -
      case CStockDataList::duplicate_entry :
        discardedCtr ++ ;
        continue;

      //      
      case CStockDataList::conflicting_entry :  
      {
        //  :     
        // ,      
        CConflictDialog aDialog;

        //  ,    
        //     
        CString strText = "Existing entry:\n\n";

        CStockData SDTemp = TempList.GetAt( CurPos );

        strText += SDTemp.GetAsString();
        strText += "\n\nReplacement entry:\n\n";
        strText += aStData.GetAsString();

        //      
        aDialog.m_REditText = strText;

        switch( aDialog.DoModal() )
        {
          case IDABORT : //   
          return FALSE;

          case IDCANCEL : //  
          discardedCtr++ ;
          continue;

          case IDOK :  //   
          TempList.SetAt( CurPos, aStData );
        }
      }
			
      default:  // OK
      addedCtr++ ;
      }
    }

    //   -   
    CString strPrompt;
    strPrompt.Format( 
      "Import of file %s complete:\nRecords loaded: %d \
      \nRecords discarded: %d  \
      \n\nHit OK to load data into document.",
      strFileHeader, addedCtr, discardedCtr );

    if ( AfxMessageBox( strPrompt, MB_OKCANCEL ) == IDOK )
    {
      //   
      m_DocList.RemoveAll();
      m_DocList.AddHead( &TempList );

      //     
      CMainFrame * pWnd = 
        dynamic_cast< CMainFrame * > (AfxGetMainWnd());

      if ( pWnd )
      {
        pWnd->UpdateFundList( m_DocList );
        //      
        pWnd->SetFundsVisible( TRUE );
      }

      return TRUE;
    }
    else
      return FALSE;

}

void CSTUploadDoc::DeleteContents() 
{
  m_DocList.RemoveAll();

  CMainFrame * pWnd = 
    dynamic_cast< CMainFrame * > (AfxGetMainWnd());

  if( pWnd )
  {
    pWnd->UpdateFundList( m_DocList );
    //     ,     
    //  ...
    pWnd->SetFundsVisible( FALSE );
    // ...      
    //   
    SetCurrentFund("");
  }
	
  CDocument::DeleteContents();
}

void CSTUploadDoc::OnDataQuerydatabase() 
{
CQueryDialog aQDlg;
	
//      Date Time Picker 
//       (  )
CStockData sdFirst = m_DocList.GetHead();
CStockData sdLast = m_DocList.GetTail();

aQDlg.m_fromdate = sdFirst.GetDate();
aQDlg.m_todate = sdLast.GetDate();

if( aQDlg.DoModal() == IDOK )
{
	//  
	CString strQuery = "select * from PriceHistory where ph_fund = '";
	strQuery += aQDlg.m_strFund;
	strQuery += "' and ph_date between '";
	strQuery += aQDlg.m_fromdate.Format( "%Y/%m/%d" );
	strQuery += "' and '";
	strQuery += aQDlg.m_todate.Format( "%Y/%m/%d" );
	strQuery += "'";

	//   
	CString strCaption = aQDlg.m_strFund;
	strCaption += " Prices ";
	strCaption += aQDlg.m_fromdate.Format( "%d/%m/%Y" );
	strCaption += " - ";
	strCaption += aQDlg.m_todate.Format( "%d/%m/%Y" );

	CResultsDialog rd;

	rd.m_strQuery = strQuery;
	rd.m_strCaption = strCaption;

	rd.DoModal();

}	

	
}

void CSTUploadDoc::OnUpdateDataQuerydatabase(CCmdUI* pCmdUI) 
{
//   Query Database ,  
//         

BOOL bEnable = FALSE;

bEnable = m_strCurrentFund.IsEmpty() ? FALSE : TRUE;

pCmdUI->Enable( bEnable );		
}

void CSTUploadDoc::OnDataUpload() 
{
	if( AfxMessageBox( "Upload current file to database?",
					   MB_OKCANCEL ) == IDCANCEL )
		return;


	::CoInitialize( NULL ); 

	_COM_SMARTPTR_TYPEDEF(IUploadStockData, __uuidof(IUploadStockData));
	 
	IUploadStockDataPtr pServer;

	HRESULT hr = pServer.CreateInstance( CLSID_UploadStockData );

	if( SUCCEEDED( hr ) )
		hr = pServer->ConnectToDatabase();


	if( SUCCEEDED( hr ) )
	{
		try
		{
			POSITION pos = m_DocList.GetHeadPosition();

			while( pos )
			{
				CStockData sd = m_DocList.GetNext( pos );

				BSTR fund = sd.GetFund().AllocSysString();
				DATE date = sd.GetDate().m_dt;
				double price = sd.GetPrice();

				DWORD dwLen = UNLEN + 1;
				TCHAR cUser[ UNLEN + 1 ];
				::GetUserName( cUser, &dwLen );
				CString strUser( cUser );

				BSTR uplBy = (strUser.Left( 10 )).AllocSysString();
				COleDateTime dtToday = COleDateTime::GetCurrentTime();
				DATE uplDate = dtToday.m_dt;

				HRESULT hr = pServer->UploadRecord(fund,  
					date, price, uplBy, uplDate);

				::SysFreeString( fund );
				::SysFreeString( uplBy );

				if( FAILED( hr ))
				{
					CString strPrompt = "Upload of:\n";
					strPrompt += sd.GetAsString();
					strPrompt += "\nfailed";
					
					if( AfxMessageBox( strPrompt, MB_OKCANCEL ) == IDCANCEL )
						break;
				}
						 
			}

			if( !pos ) //     
				AfxMessageBox( "Upload completed successfully" );
		}
		catch( _com_error e )
		{
			::MessageBox( NULL, e.ErrorMessage(), NULL, MB_OK );
		}
		pServer->Disconnect();

	}

	::CoUninitialize();
	
}

void CSTUploadDoc::OnUpdateDataUpload(CCmdUI* pCmdUI) 
{
    //    UploadData,     
	//       - 
	//  
    BOOL bEnable = GetCurrentFund().IsEmpty() ? FALSE : TRUE;
    pCmdUI->Enable(bEnable); 
	
}
